Index: include/asterisk/options.h
===================================================================
--- include/asterisk/options.h	(revision 34061)
+++ include/asterisk/options.h	(working copy)
@@ -23,6 +23,9 @@
 #ifndef _ASTERISK_OPTIONS_H
 #define _ASTERISK_OPTIONS_H
 
+enum ast_trans_algorithm { AST_TRANS_ALG_STRICT, AST_TRANS_ALG_LOOSE };
+extern enum ast_trans_algorithm option_translation_algorithm;
+
 #if defined(__cplusplus) || defined(c_plusplus)
 extern "C" {
 #endif
Index: include/asterisk/pbx.h
===================================================================
--- include/asterisk/pbx.h	(revision 34061)
+++ include/asterisk/pbx.h	(working copy)
@@ -687,11 +687,11 @@
 
 /*! Synchronously or asynchronously make an outbound call and send it to a
    particular extension */
-int ast_pbx_outgoing_exten(const char *type, int format, void *data, int timeout, const char *context, const char *exten, int priority, int *reason, int sync, const char *cid_num, const char *cid_name, struct ast_variable *vars, const char *account, struct ast_channel **locked_channel);
+int ast_pbx_outgoing_exten(const char *type, const struct ast_codec_pref *formats, void *data, int timeout, const char *context, const char *exten, int priority, int *reason, int sync, const char *cid_num, const char *cid_name, struct ast_variable *vars, const char *account, struct ast_channel **locked_channel);
 
 /*! Synchronously or asynchronously make an outbound call and send it to a
    particular application with given extension */
-int ast_pbx_outgoing_app(const char *type, int format, void *data, int timeout, const char *app, const char *appdata, int *reason, int sync, const char *cid_num, const char *cid_name, struct ast_variable *vars, const char *account, struct ast_channel **locked_channel);
+int ast_pbx_outgoing_app(const char *type, const struct ast_codec_pref *formats, void *data, int timeout, const char *app, const char *appdata, int *reason, int sync, const char *cid_num, const char *cid_name, struct ast_variable *vars, const char *account, struct ast_channel **locked_channel);
 
 /*!
  * \brief Evaluate a condition
Index: include/asterisk/rtp.h
===================================================================
--- include/asterisk/rtp.h	(revision 34061)
+++ include/asterisk/rtp.h	(working copy)
@@ -49,6 +49,17 @@
 #define AST_RTP_MAX             	AST_RTP_CISCO_DTMF
 
 #define MAX_RTP_PT			256
+/*
+ * RFC3551, Section 6:
+ *  "...payload type values in the range 96-127 MAY be defined dynamically..."
+ */
+#define MAX_RTP_STATIC_PT               95
+
+/*! \brief The value of each payload format mapping: */
+struct rtpPayloadType {
+	int isAstFormat; 	/*!< whether the following code is an AST_FORMAT */
+	int code;
+};
 
 struct ast_rtp_protocol {
 	/*! Get RTP struct, or NULL if unwilling to transfer */
@@ -56,8 +67,7 @@
 	/*! Get RTP struct, or NULL if unwilling to transfer */
 	struct ast_rtp *(* const get_vrtp_info)(struct ast_channel *chan);
 	/*! Set RTP peer */
-	int (* const set_rtp_peer)(struct ast_channel *chan, struct ast_rtp *peer, struct ast_rtp *vpeer, int codecs, int nat_active);
-	int (* const get_codec)(struct ast_channel *chan);
+	int (* const set_rtp_peer)(struct ast_channel *chan, struct ast_rtp *peer, struct ast_rtp *vpeer, const struct ast_codec_pref *codecs, int nat_active);
 	const char * const type;
 	AST_LIST_ENTRY(ast_rtp_protocol) list;
 };
Index: include/asterisk/translate.h
===================================================================
--- include/asterisk/translate.h	(revision 34061)
+++ include/asterisk/translate.h	(working copy)
@@ -38,6 +38,7 @@
 #endif
 
 struct ast_trans_pvt;	/* declared below */
+struct ast_channel;
 
 /*! \brief
  * Descriptor of a translator. Name, callbacks, and various options
@@ -191,6 +192,13 @@
  */
 void ast_translator_free_path(struct ast_trans_pvt *tr);
 
+/*! Frees a translation path matrix assosiated with channel */
+/*!
+ * \param chan channel to free translation path matrix
+ * Frees the translation matrix in the given channel
+ */
+extern void ast_translator_free_translations(struct ast_channel *chan);
+
 /*!
  * \brief translates one or more frames
  * Apply an input frame into the translator and receive zero or one output frames.  Consume
@@ -201,6 +209,35 @@
  * \return an ast_frame of the new translation format on success, NULL on failure
  */
 struct ast_frame *ast_translate(struct ast_trans_pvt *tr, struct ast_frame *f, int consume);
+/*! translates read frames */
+/*!
+ * \param chan channel through which the frame comes in
+ * \param f frame to translate
+ * \param consume Whether or not to free the original frame
+ * Translate frame into the readformat of the channel from any format and receive
+ * zero or one output frames.  Consume determines whether the original frame 
+ * should be freed.
+ * Returns an ast_frame of the new translation format on success, NULL on failure
+ */
+extern struct ast_frame *ast_translate_read(struct ast_channel *chan, struct ast_frame *f, int consume);
+/*! translates frames for writing */
+/*!
+ * \param chan channel through which the frame comes out
+ * \param f frame to translate
+ * \param consume Whether or not to free the original frame
+ * Translate frame into the writeformat of the channel from any format and receive
+ * zero or one output frames.  Consume determines whether the original frame 
+ * should be freed.
+ * Returns an ast_frame of the new translation format on success, NULL on failure
+ */
+extern struct ast_frame *ast_translate_write(struct ast_channel *chan, struct ast_frame *f, int consume);
+
+/*!
+ * Returns all formats that can be converted by asterisk from/to supplied format
+ * plus the format itself.
+ * \param formats formats for which to search compatible formats
+ */
+extern int ast_compatible_audio_formats(int format);
 
 /*!
  * \brief Returns the number of steps required to convert from 'src' to 'dest'.
Index: manager.c
===================================================================
--- manager.c	(revision 34061)
+++ manager.c	(working copy)
@@ -1305,14 +1305,18 @@
 	int res;
 	int reason = 0;
 	struct ast_channel *chan = NULL;
+	struct ast_codec_pref slin;
+
+	ast_codec_pref_init(&slin);
+	ast_codec_pref_append(&slin, AST_FORMAT_SLINEAR);
 
 	if (!ast_strlen_zero(in->app)) {
-		res = ast_pbx_outgoing_app(in->tech, AST_FORMAT_SLINEAR, in->data, in->timeout, in->app, in->appdata, &reason, 1, 
+		res = ast_pbx_outgoing_app(in->tech, &slin, in->data, in->timeout, in->app, in->appdata, &reason, 1, 
 			S_OR(in->cid_num, NULL), 
 			S_OR(in->cid_name, NULL),
 			in->vars, in->account, &chan);
 	} else {
-		res = ast_pbx_outgoing_exten(in->tech, AST_FORMAT_SLINEAR, in->data, in->timeout, in->context, in->exten, in->priority, &reason, 1, 
+		res = ast_pbx_outgoing_exten(in->tech, &slin, in->data, in->timeout, in->context, in->exten, in->priority, &reason, 1, 
 			S_OR(in->cid_num, NULL), 
 			S_OR(in->cid_name, NULL),
 			in->vars, in->account, &chan);
@@ -1385,6 +1389,11 @@
 	
 	pthread_t th;
 	pthread_attr_t attr;
+	struct ast_codec_pref slin;
+	
+	memset(&slin, 0, sizeof(&slin));
+	ast_codec_pref_append(&slin, AST_FORMAT_SLINEAR);
+	
 	if (!name) {
 		astman_send_error(s, m, "Channel not specified");
 		return 0;
@@ -1449,10 +1458,10 @@
 			}
 		}
 	} else if (!ast_strlen_zero(app)) {
-        	res = ast_pbx_outgoing_app(tech, AST_FORMAT_SLINEAR, data, to, app, appdata, &reason, 1, l, n, vars, account, NULL);
+        	res = ast_pbx_outgoing_app(tech, &slin, data, to, app, appdata, &reason, 1, l, n, vars, account, NULL);
     	} else {
 		if (exten && context && pi)
-	        	res = ast_pbx_outgoing_exten(tech, AST_FORMAT_SLINEAR, data, to, context, exten, pi, &reason, 1, l, n, vars, account, NULL);
+	        	res = ast_pbx_outgoing_exten(tech, &slin, data, to, context, exten, pi, &reason, 1, l, n, vars, account, NULL);
 		else {
 			astman_send_error(s, m, "Originate with 'Exten' requires 'Context' and 'Priority'");
 			return 0;
Index: pbx.c
===================================================================
--- pbx.c	(revision 34061)
+++ pbx.c	(working copy)
@@ -4521,7 +4521,7 @@
 	return 0;  /* success */
 }
 
-int ast_pbx_outgoing_exten(const char *type, int format, void *data, int timeout, const char *context, const char *exten, int priority, int *reason, int sync, const char *cid_num, const char *cid_name, struct ast_variable *vars, const char *account, struct ast_channel **channel)
+int ast_pbx_outgoing_exten(const char *type, const struct ast_codec_pref *formats, void *data, int timeout, const char *context, const char *exten, int priority, int *reason, int sync, const char *cid_num, const char *cid_name, struct ast_variable *vars, const char *account, struct ast_channel **channel)
 {
 	struct ast_channel *chan;
 	struct async_stat *as;
@@ -4531,7 +4531,7 @@
 
 	if (sync) {
 		LOAD_OH(oh);
-		chan = __ast_request_and_dial(type, format, data, timeout, reason, cid_num, cid_name, &oh);
+		chan = __ast_request_and_dial(type, formats, data, timeout, reason, cid_num, cid_name, &oh);
 		if (channel) {
 			*channel = chan;
 			if (chan)
@@ -4628,7 +4628,7 @@
 			res = -1;
 			goto outgoing_exten_cleanup;
 		}
-		chan = ast_request_and_dial(type, format, data, timeout, reason, cid_num, cid_name);
+		chan = ast_request_and_dial(type, formats, data, timeout, reason, cid_num, cid_name);
 		if (channel) {
 			*channel = chan;
 			if (chan)
@@ -4690,7 +4690,7 @@
 	return NULL;
 }
 
-int ast_pbx_outgoing_app(const char *type, int format, void *data, int timeout, const char *app, const char *appdata, int *reason, int sync, const char *cid_num, const char *cid_name, struct ast_variable *vars, const char *account, struct ast_channel **locked_channel)
+int ast_pbx_outgoing_app(const char *type, const struct ast_codec_pref *formats, void *data, int timeout, const char *app, const char *appdata, int *reason, int sync, const char *cid_num, const char *cid_name, struct ast_variable *vars, const char *account, struct ast_channel **locked_channel)
 {
 	struct ast_channel *chan;
 	struct app_tmp *tmp;
@@ -4709,7 +4709,7 @@
 		goto outgoing_app_cleanup;
 	}
 	if (sync) {
-		chan = __ast_request_and_dial(type, format, data, timeout, reason, cid_num, cid_name, &oh);
+		chan = __ast_request_and_dial(type, formats, data, timeout, reason, cid_num, cid_name, &oh);
 		if (chan) {
 			if (chan->cdr) { /* check if the channel already has a cdr record, if not give it one */
 				ast_log(LOG_WARNING, "%s already has a call record??\n", chan->name);
@@ -4792,7 +4792,7 @@
 			res = -1;
 			goto outgoing_app_cleanup;
 		}
-		chan = __ast_request_and_dial(type, format, data, timeout, reason, cid_num, cid_name, &oh);
+		chan = __ast_request_and_dial(type, formats, data, timeout, reason, cid_num, cid_name, &oh);
 		if (!chan) {
 			free(as);
 			res = -1;
Index: pbx/pbx_spool.c
===================================================================
--- pbx/pbx_spool.c	(revision 34061)
+++ pbx/pbx_spool.c	(working copy)
@@ -328,14 +328,19 @@
 {
 	struct outgoing *o = data;
 	int res, reason;
+	struct ast_codec_pref slin;
+
+	ast_codec_pref_init(&slin);
+	ast_codec_pref_append(&slin, AST_FORMAT_SLINEAR);
+	
 	if (!ast_strlen_zero(o->app)) {
 		if (option_verbose > 2)
 			ast_verbose(VERBOSE_PREFIX_3 "Attempting call on %s/%s for application %s(%s) (Retry %d)\n", o->tech, o->dest, o->app, o->data, o->retries);
-		res = ast_pbx_outgoing_app(o->tech, AST_FORMAT_SLINEAR, o->dest, o->waittime * 1000, o->app, o->data, &reason, 2 /* wait to finish */, o->cid_num, o->cid_name, o->vars, o->account, NULL);
+		res = ast_pbx_outgoing_app(o->tech, &slin, o->dest, o->waittime * 1000, o->app, o->data, &reason, 2 /* wait to finish */, o->cid_num, o->cid_name, o->vars, o->account, NULL);
 	} else {
 		if (option_verbose > 2)
 			ast_verbose(VERBOSE_PREFIX_3 "Attempting call on %s/%s for %s@%s:%d (Retry %d)\n", o->tech, o->dest, o->exten, o->context,o->priority, o->retries);
-		res = ast_pbx_outgoing_exten(o->tech, AST_FORMAT_SLINEAR, o->dest, o->waittime * 1000, o->context, o->exten, o->priority, &reason, 2 /* wait to finish */, o->cid_num, o->cid_name, o->vars, o->account, NULL);
+		res = ast_pbx_outgoing_exten(o->tech, &slin, o->dest, o->waittime * 1000, o->context, o->exten, o->priority, &reason, 2 /* wait to finish */, o->cid_num, o->cid_name, o->vars, o->account, NULL);
 	}
 	if (res) {
 		ast_log(LOG_NOTICE, "Call failed to go through, reason %d\n", reason);
Index: res/res_clioriginate.c
===================================================================
--- res/res_clioriginate.c	(revision 34061)
+++ res/res_clioriginate.c	(working copy)
@@ -72,6 +72,8 @@
 	char *chantech;
 	char *chandata;
 	int reason = 0;
+	struct ast_codec_pref slin;
+	ast_codec_pref_set2(&slin, AST_FORMAT_SLINEAR);
 	
 	if (ast_strlen_zero(app))
 		return RESULT_SHOWUSAGE;
@@ -84,7 +86,7 @@
 		return RESULT_SHOWUSAGE;
 	}
 
-	ast_pbx_outgoing_app(chantech, AST_FORMAT_SLINEAR, chandata, TIMEOUT * 1000, app, appdata, &reason, 1, NULL, NULL, NULL, NULL, NULL);
+	ast_pbx_outgoing_app(chantech, &slin, chandata, TIMEOUT * 1000, app, appdata, &reason, 1, NULL, NULL, NULL, NULL, NULL);
 
 	return RESULT_SUCCESS;
 }
@@ -96,6 +98,8 @@
 	char *exten = NULL;
 	char *context = NULL;
 	int reason = 0;
+	struct ast_codec_pref slin;
+	ast_codec_pref_set2(&slin, AST_FORMAT_SLINEAR);
 
 	chandata = ast_strdupa(chan);
 	
@@ -115,7 +119,7 @@
 	if (ast_strlen_zero(context))
 		context = "default";
 	
-	ast_pbx_outgoing_exten(chantech, AST_FORMAT_SLINEAR, chandata, TIMEOUT * 1000, context, exten, 1, &reason, 1, NULL, NULL, NULL, NULL, NULL);
+	ast_pbx_outgoing_exten(chantech, &slin, chandata, TIMEOUT * 1000, context, exten, 1, &reason, 1, NULL, NULL, NULL, NULL, NULL);
 
 	return RESULT_SUCCESS;
 }
Index: res/res_features.c
===================================================================
--- res/res_features.c	(revision 34061)
+++ res/res_features.c	(working copy)
@@ -207,7 +207,7 @@
 	}
 }
 
-static struct ast_channel *ast_feature_request_and_dial(struct ast_channel *caller, const char *type, int format, void *data, int timeout, int *outstate, const char *cid_num, const char *cid_name);
+static struct ast_channel *ast_feature_request_and_dial(struct ast_channel *caller, const char *type, const struct ast_codec_pref *formats, void *data, int timeout, int *outstate, const char *cid_num, const char *cid_name);
 
 
 static void *ast_bridge_call_thread(void *data) 
@@ -724,7 +724,7 @@
 
 	l = strlen(xferto);
 	snprintf(xferto + l, sizeof(xferto) - l, "@%s/n", transferer_real_context);	/* append context */
-	newchan = ast_feature_request_and_dial(transferer, "Local", ast_best_codec(transferer->nativeformats),
+	newchan = ast_feature_request_and_dial(transferer, "Local", &transferer->nativeformats,
 		xferto, atxfernoanswertimeout, &outstate, transferer->cid.cid_num, transferer->cid.cid_name);
 	ast_indicate(transferer, -1);
 	if (!newchan) {
@@ -1026,7 +1026,7 @@
 }
 
 /*! \todo XXX Check - this is very similar to the code in channel.c */
-static struct ast_channel *ast_feature_request_and_dial(struct ast_channel *caller, const char *type, int format, void *data, int timeout, int *outstate, const char *cid_num, const char *cid_name)
+static struct ast_channel *ast_feature_request_and_dial(struct ast_channel *caller, const char *type, const struct ast_codec_pref *formats, void *data, int timeout, int *outstate, const char *cid_num, const char *cid_name)
 {
 	int state = 0;
 	int cause = 0;
@@ -1036,7 +1036,7 @@
 	struct ast_channel *active_channel;
 	int res = 0, ready = 0;
 	
-	if ((chan = ast_request(type, format, data, &cause))) {
+	if ((chan = ast_request(type, formats, data, &cause))) {
 		ast_set_callerid(chan, cid_num, cid_name, cid_num);
 		ast_channel_inherit_variables(caller, chan);	
 		pbx_builtin_setvar_helper(chan, "TRANSFERERNAME", caller->name);
@@ -1242,6 +1242,27 @@
 	set_config_flags(chan, peer, config);
 	config->firstpass = 1;
 
+	if (ast_codec_pref_intersect(&chan->nativeformats, &peer->nativeformats))
+       	{
+		if (chan->tech->fixup_codecs && 
+		    ast_codec_pref_intersect(&chan->nativeformats, &peer->nativeformats) != ast_codec_pref_bits(&chan->nativeformats))
+		{
+			struct ast_codec_pref tmp;
+			memcpy(&tmp, &peer->nativeformats, sizeof(tmp));
+			/* Provide all compatible formats also */
+			ast_codec_pref_append_missing2(&tmp, ast_compatible_audio_formats(tmp.audio_bits));
+			chan->tech->fixup_codecs(chan, &tmp);
+		}
+		if (peer->tech->fixup_codecs && 
+		    ast_codec_pref_intersect(&chan->nativeformats, &peer->nativeformats) != ast_codec_pref_bits(&peer->nativeformats))
+		{
+			struct ast_codec_pref tmp;
+			memcpy(&tmp, &peer->nativeformats, sizeof(tmp));
+			/* Provide all compatible formats also */
+			ast_codec_pref_append_missing2(&tmp, ast_compatible_audio_formats(tmp.audio_bits));
+			peer->tech->fixup_codecs(peer, &tmp);
+		}
+	}
 	/* Answer if need be */
 	if (ast_answer(chan))
 		return -1;
Index: rtp.c
===================================================================
--- rtp.c	(revision 34061)
+++ rtp.c	(working copy)
@@ -56,6 +56,7 @@
 #include "asterisk/cli.h"
 #include "asterisk/unaligned.h"
 #include "asterisk/utils.h"
+#include "asterisk/translate.h"
 
 #define MAX_TIMESTAMP_SKEW	640
 
@@ -96,11 +97,6 @@
  * RTP session is defined on page 9 of RFC 3550: "An association among a set of participants communicating with RTP.  A participant may be involved in multiple RTP sessions at the same time [...]"
  *
  */
-/*! \brief The value of each payload format mapping: */
-struct rtpPayloadType {
-	int isAstFormat; 	/*!< whether the following code is an AST_FORMAT */
-	int code;
-};
 
 
 /*! \brief RTP session description */
@@ -164,6 +160,7 @@
 static int ast_rtcp_write_rr(void *data);
 static unsigned int ast_rtcp_calc_interval(struct ast_rtp *rtp);
 
+
 #define FLAG_3389_WARNING		(1 << 0)
 #define FLAG_NAT_ACTIVE			(3 << 1)
 #define FLAG_NAT_INACTIVE		(0 << 1)
@@ -1292,7 +1289,7 @@
 	struct ast_rtp *destp, *srcp=NULL;		/* Audio RTP Channels */
 	struct ast_rtp *vdestp, *vsrcp=NULL;		/* Video RTP channels */
 	struct ast_rtp_protocol *destpr, *srcpr=NULL;
-	int srccodec;
+	struct ast_codec_pref srccodecs;
 
 	/* Lock channels */
 	ast_channel_lock(dest);
@@ -1341,15 +1338,12 @@
 			ast_channel_unlock(src);
 		return 0;
 	}
-	if (srcpr && srcpr->get_codec)
-		srccodec = srcpr->get_codec(src);
-	else
-		srccodec = 0;
+	memcpy(&srccodecs, &src->nativeformats, sizeof(srccodecs));
 	/* Consider empty media as non-existant */
 	if (srcp && !srcp->them.sin_addr.s_addr)
 		srcp = NULL;
 	/* Bridge media early */
-	if (destpr->set_rtp_peer(dest, srcp, vsrcp, srccodec, srcp ? ast_test_flag(srcp, FLAG_NAT_ACTIVE) : 0))
+	if (destpr->set_rtp_peer(dest, srcp, vsrcp, &srccodecs, srcp ? ast_test_flag(srcp, FLAG_NAT_ACTIVE) : 0))
 		ast_log(LOG_WARNING, "Channel '%s' failed to setup early bridge to '%s'\n", dest->name, src ? src->name : "<unspecified>");
 	ast_channel_unlock(dest);
 	if (src)
@@ -1364,7 +1358,7 @@
 	struct ast_rtp *destp, *srcp;		/* Audio RTP Channels */
 	struct ast_rtp *vdestp, *vsrcp;		/* Video RTP channels */
 	struct ast_rtp_protocol *destpr, *srcpr;
-	int srccodec;
+	struct ast_codec_pref srccodecs;
 	/* Lock channels */
 	ast_channel_lock(dest);
 	while(ast_channel_trylock(src)) {
@@ -1407,13 +1401,10 @@
 	ast_rtp_pt_copy(destp, srcp);
 	if (vdestp && vsrcp)
 		ast_rtp_pt_copy(vdestp, vsrcp);
-	if (srcpr->get_codec)
-		srccodec = srcpr->get_codec(src);
-	else
-		srccodec = 0;
+	memcpy(&srccodecs, &src->nativeformats, sizeof(srccodecs));
 	if (media) {
 		/* Bridge early */
-		if (destpr->set_rtp_peer(dest, srcp, vsrcp, srccodec, ast_test_flag(srcp, FLAG_NAT_ACTIVE)))
+		if (destpr->set_rtp_peer(dest, srcp, vsrcp, &srccodecs, ast_test_flag(srcp, FLAG_NAT_ACTIVE)))
 			ast_log(LOG_WARNING, "Channel '%s' failed to setup early bridge to '%s'\n", dest->name, src->name);
 	}
 	ast_channel_unlock(dest);
@@ -1429,8 +1420,11 @@
  */
 void ast_rtp_set_m_type(struct ast_rtp* rtp, int pt) 
 {
-	if (pt < 0 || pt > MAX_RTP_PT) 
-		return; /* bogus payload type */
+	/*
+	 * Get only static payload types here
+	 */
+	if (pt < 0 || pt > MAX_RTP_STATIC_PT) 
+		return; /* non-static payload type */
 
 	if (static_RTP_PT[pt].code != 0) 
 		rtp->current_RTP_PT[pt] = static_RTP_PT[pt];
@@ -2490,11 +2484,15 @@
 	
 	void *pvt0, *pvt1;
 	int codec0,codec1, oldcodec0, oldcodec1;
+        struct ast_codec_pref codecs0;
+        struct ast_codec_pref codecs1;
 	
 	memset(&vt0, 0, sizeof(vt0));
 	memset(&vt1, 0, sizeof(vt1));
 	memset(&vac0, 0, sizeof(vac0));
 	memset(&vac1, 0, sizeof(vac1));
+        ast_codec_pref_init(&codecs0);
+        ast_codec_pref_init(&codecs1);
 
 	/* Lock channels */
 	ast_channel_lock(c0);
@@ -2557,24 +2555,24 @@
 	}
 
 	/* Get codecs from both sides */
-	codec0 = pr0->get_codec ? pr0->get_codec(c0) : 0;
-	codec1 = pr1->get_codec ? pr1->get_codec(c1) : 0;
-	if (pr0->get_codec && pr1->get_codec) {
-		/* Hey, we can't do reinvite if both parties speak different codecs */
-		if (!(codec0 & codec1)) {
-			if (option_debug)
-				ast_log(LOG_DEBUG, "Channel codec0 = %d is not codec1 = %d, cannot native bridge in RTP.\n", codec0, codec1);
-			ast_channel_unlock(c0);
-			ast_channel_unlock(c1);
-			return AST_BRIDGE_FAILED_NOWARN;
-		}
+	codec0 = ast_codec_pref_bits(&c0->nativeformats);
+	codec1 = ast_codec_pref_bits(&c1->nativeformats);
+	memcpy(&codecs0, &c0->nativeformats, sizeof(codecs0));
+	memcpy(&codecs1, &c1->nativeformats, sizeof(codecs1));
+	/* Hey, we can't do reinvite if both parties speak different codecs */
+	if (!(codec0 & codec1)) {
+		if (option_debug)
+			ast_log(LOG_DEBUG, "Channel codec0 = %d is not codec1 = %d, cannot native bridge in RTP.\n", codec0, codec1);
+		ast_channel_unlock(c0);
+		ast_channel_unlock(c1);
+		return AST_BRIDGE_FAILED_NOWARN;
 	}
 
 	if (option_verbose > 2) 
 		ast_verbose(VERBOSE_PREFIX_3 "Native bridging %s and %s\n", c0->name, c1->name);
 
 	/* Ok, we should be able to redirect the media. Start with one channel */
-	if (pr0->set_rtp_peer(c0, p1, vp1, codec1, ast_test_flag(p1, FLAG_NAT_ACTIVE))) 
+	if (pr0->set_rtp_peer(c0, p1, vp1, &codecs1, ast_test_flag(p1, FLAG_NAT_ACTIVE))) 
 		ast_log(LOG_WARNING, "Channel '%s' failed to talk to '%s'\n", c0->name, c1->name);
 	else {
 		/* Store RTP peer */
@@ -2583,7 +2581,7 @@
 			ast_rtp_get_peer(vp1, &vac1);
 	}
 	/* Then test the other channel */
-	if (pr1->set_rtp_peer(c1, p0, vp0, codec0, ast_test_flag(p0, FLAG_NAT_ACTIVE)))
+	if (pr1->set_rtp_peer(c1, p0, vp0, &codecs0, ast_test_flag(p0, FLAG_NAT_ACTIVE)))
 		ast_log(LOG_WARNING, "Channel '%s' failed to talk back to '%s'\n", c1->name, c0->name);
 	else {
 		/* Store RTP peer */
@@ -2607,11 +2605,11 @@
 			(c0->masq || c0->masqr || c1->masq || c1->masqr)) {
 				ast_log(LOG_DEBUG, "Oooh, something is weird, backing out\n");
 				if (c0->tech_pvt == pvt0) {
-					if (pr0->set_rtp_peer(c0, NULL, NULL, 0, 0)) 
+					if (pr0->set_rtp_peer(c0, NULL, NULL, NULL, 0)) 
 						ast_log(LOG_WARNING, "Channel '%s' failed to break RTP bridge\n", c0->name);
 				}
 				if (c1->tech_pvt == pvt1) {
-					if (pr1->set_rtp_peer(c1, NULL, NULL, 0, 0)) 
+					if (pr1->set_rtp_peer(c1, NULL, NULL, NULL, 0)) 
 						ast_log(LOG_WARNING, "Channel '%s' failed to break RTP bridge\n", c1->name);
 				}
 				return AST_BRIDGE_RETRY;
@@ -2619,10 +2617,8 @@
 		/* Now check if they have changed address */
 		ast_rtp_get_peer(p1, &t1);
 		ast_rtp_get_peer(p0, &t0);
-		if (pr0->get_codec)
-			codec0 = pr0->get_codec(c0);
-		if (pr1->get_codec)
-			codec1 = pr1->get_codec(c1);
+		codec0 = ast_codec_pref_bits(&c0->nativeformats);
+		codec1 = ast_codec_pref_bits(&c1->nativeformats);
 		if (vp1)
 			ast_rtp_get_peer(vp1, &vt1);
 		if (vp0)
@@ -2638,7 +2634,9 @@
 				ast_log(LOG_DEBUG, "Oooh, '%s' was %s:%d/(format %d)\n", 
 					c1->name, ast_inet_ntoa(iabuf, sizeof(iabuf), vac1.sin_addr), ntohs(vac1.sin_port), oldcodec1);
 			}
-			if (pr0->set_rtp_peer(c0, t1.sin_addr.s_addr ? p1 : NULL, vt1.sin_addr.s_addr ? vp1 : NULL, codec1, ast_test_flag(p1, FLAG_NAT_ACTIVE))) 
+                        memcpy(&codecs1, &c1->nativeformats, sizeof(codecs1));
+                        ast_codec_pref_append_missing2(&codecs1, ast_compatible_audio_formats(codecs1.audio_bits));
+			if (pr0->set_rtp_peer(c0, t1.sin_addr.s_addr ? p1 : NULL, vt1.sin_addr.s_addr ? vp1 : NULL, &codecs1, ast_test_flag(p1, FLAG_NAT_ACTIVE))) 
 				ast_log(LOG_WARNING, "Channel '%s' failed to update to '%s'\n", c0->name, c1->name);
 			memcpy(&ac1, &t1, sizeof(ac1));
 			memcpy(&vac1, &vt1, sizeof(vac1));
@@ -2651,7 +2649,9 @@
 				ast_log(LOG_DEBUG, "Oooh, '%s' was %s:%d/(format %d)\n", 
 					c0->name, ast_inet_ntoa(iabuf, sizeof(iabuf), ac0.sin_addr), ntohs(ac0.sin_port), oldcodec0);
 			}
-			if (pr1->set_rtp_peer(c1, t0.sin_addr.s_addr ? p0 : NULL, vt0.sin_addr.s_addr ? vp0 : NULL, codec0, ast_test_flag(p0, FLAG_NAT_ACTIVE)))
+                        memcpy(&codecs0, &c0->nativeformats, sizeof(codecs0));
+                        ast_codec_pref_append_missing2(&codecs0, ast_compatible_audio_formats(codecs0.audio_bits));
+			if (pr1->set_rtp_peer(c1, t0.sin_addr.s_addr ? p0 : NULL, vt0.sin_addr.s_addr ? vp0 : NULL, &codecs0, ast_test_flag(p0, FLAG_NAT_ACTIVE)))
 				ast_log(LOG_WARNING, "Channel '%s' failed to update to '%s'\n", c1->name, c0->name);
 			memcpy(&ac0, &t0, sizeof(ac0));
 			memcpy(&vac0, &vt0, sizeof(vac0));
Index: translate.c
===================================================================
--- translate.c	(revision 34061)
+++ translate.c	(working copy)
@@ -241,6 +241,23 @@
 
 /* end of callback wrappers and helpers */
 
+void ast_translator_free_translations(struct ast_channel *chan)
+{
+	int x, y;
+	for (x = 0; x < MAX_FORMAT; ++x) {
+		for (y = 0; y < MAX_FORMAT; ++y) {
+			if (chan->readtrans_matrix[x][y]) {
+				ast_translator_free_path(chan->readtrans_matrix[x][y]);
+				chan->readtrans_matrix[x][y] = NULL;
+			}
+			if (chan->writetrans_matrix[x][y]) {
+				ast_translator_free_path(chan->writetrans_matrix[x][y]);
+				chan->writetrans_matrix[x][y] = NULL;
+			}
+		}
+	}
+}
+
 void ast_translator_free_path(struct ast_trans_pvt *p)
 {
 	struct ast_trans_pvt *pn = p;
@@ -284,6 +301,66 @@
 	return head;
 }
 
+struct ast_frame *ast_translate_read(struct ast_channel *chan, struct ast_frame *f, int consume)
+{
+	int dest_codec;
+	int dest_codec_idx;
+	int src_codec_idx;
+	struct ast_trans_pvt *trans;
+
+	chan->lastreadformat = f->subclass;
+	/* If the user perspective is this codec then do not translate */
+	if (chan->readformat & f->subclass) {
+		return f;
+	}
+	/* Otherwise translate into the user perspective codec */
+	dest_codec = chan->readformat;
+	dest_codec_idx = powerof(dest_codec);
+	src_codec_idx = powerof(f->subclass);
+	ast_mutex_lock(&chan->lock);
+	trans = chan->readtrans_matrix[src_codec_idx][dest_codec_idx];
+	if (NULL == trans) {
+		trans = ast_translator_build_path(dest_codec, f->subclass);
+		chan->readtrans_matrix[src_codec_idx][dest_codec_idx] = trans;
+	}
+	ast_mutex_unlock(&chan->lock);
+	if (trans)
+		f = ast_translate(trans, f, consume);
+	return f;
+}
+
+struct ast_frame *ast_translate_write(struct ast_channel *chan, struct ast_frame *f, int consume)
+{
+	int dest_codec;
+	int dest_codec_idx;
+	int src_codec_idx;
+	struct ast_trans_pvt *trans;
+	/* If channel supports this codec then do not translate */
+	if ((chan->nativeformats.audio_bits & f->subclass) &&
+	    ((option_translation_algorithm == AST_TRANS_ALG_LOOSE) ||
+	     (f->subclass & chan->lastreadformat)))
+	{
+		return f;
+	}
+	/*
+	 * Use the codec that the UA is using currently
+	 * (faxing does not work without this for example)
+	 */
+	dest_codec = chan->lastreadformat;
+	dest_codec_idx = powerof(dest_codec);
+	src_codec_idx = powerof(f->subclass);
+	ast_mutex_lock(&chan->lock);
+	trans = chan->writetrans_matrix[src_codec_idx][dest_codec_idx];
+	if (NULL == trans) {
+		trans = ast_translator_build_path(dest_codec, f->subclass);
+		chan->writetrans_matrix[src_codec_idx][dest_codec_idx] = trans;
+	}
+	ast_mutex_unlock(&chan->lock);
+	if (trans)
+		f = ast_translate(trans, f, consume);
+	return f;
+}
+
 /*! \brief do the actual translation */
 struct ast_frame *ast_translate(struct ast_trans_pvt *path, struct ast_frame *f, int consume)
 {
@@ -686,4 +763,26 @@
 		return -1;
 	else
 		return tr_matrix[src][dest].multistep + 1;
+}
+
+int ast_compatible_audio_formats(int formats)
+{
+	int retval = formats;
+	int x, y;
+
+	for (x = 0; x < MAX_FORMAT; ++x)
+	{
+		if ((1 << x) & formats)
+		{
+			for (y = 0; y < MAX_FORMAT; ++y)
+			{
+				if (tr_matrix[x][y].step)
+				{
+					retval |= (1 << y);
+				}
+			}
+		}
+	}
+	return retval;
+
 }
